'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Vue = require('vue');
var maptalks = require('maptalks');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

var options = {
  props: {
    options: {
      type: Object,
      custom: true,
      default: function _default() {
        return {};
      }
    }
  }
};

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

/**
 * omit 函数
 * @param {object} target
 * @param {string | string[]} key
 * @return {object}
 * @example omit({a: 1, b: 2}, 'a') -> {b: 2}
 */
var omit = function omit(target, key) {
  var keys = [];

  switch (true) {
    case typeof key === 'string':
      keys = [key];
      break;

    case Array.isArray(key):
      keys = key;
      break;
  } // es6 rest omit


  var _keys$pop = keys.pop();
      target[_keys$pop];
      var rest = _objectWithoutProperties(target, [_keys$pop].map(_toPropertyKey));

  if (key.length > 0) {
    return omit(rest, keys);
  }

  return rest;
};

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var mergeProps = function mergeProps(instance) {
  return omit(_objectSpread(_objectSpread(_objectSpread({}, instance.$props), instance.options), instance.$options.propsData), 'options');
};

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}

/**
 * 字符串首字母大写
 * @param {string} str
 * @return {string}
 */
var capitalize = function capitalize(str) {
  if (!str) return '';

  var _str = _toArray(str),
      first = _str[0],
      rest = _str.slice(1);

  return "".concat(first.toUpperCase()).concat(rest.join(''));
};

/**
 * 地图属性监听绑定
 * @param {Vue} instance vue 实例
 * @param {Object} element 地图实例
 * @param {string | string[] | undefined } props 不需要监听的属性,如果没有默认使用 vue 实例上的属性
 * @param {object} options 地图元素的options, 如果 props 变化,而没有对应的方法,整体设置 options
 */

var watchProps = function watchProps(instance, element, props, options) {
  var currentProps = instance.$options.props;

  if (props) {
    currentProps = omit(currentProps, props);
  }

  Object.entries(currentProps).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        propKey = _ref2[0],
        propVal = _ref2[1];

    var deep = propVal.type === Object || propVal.type === Array || Array.isArray(propVal.type);
    var methodName = "set".concat(capitalize(propKey));

    switch (true) {
      case propVal.custom && !!instance[methodName]:
        instance.$watch(propKey, function (val, oldVal) {
          instance[methodName](val, oldVal);
        }, {
          deep: deep
        });
        break;

      case !!element[methodName] && propKey !== 'options':
        instance.$watch(propKey, function (val) {
          return element[methodName](val);
        }, {
          deep: deep
        });
        break;
    }
  });
};

/**
 * map/geometry 等事件绑定
 * @param {object} element 需要绑定的元素 eg: map/circle/path
 * @param {Vue} instance vue 实例,eg: this
 * @param {string[] | undefined} omitEvent 需要监听的事件
 */

var bindEvent = function bindEvent(element, instance, omitEvent) {
  var listeners = omit(instance.$listeners, omitEvent);
  element.addEventListener(listeners);
  instance.$once('hook:beforeDestroy', function () {
    element.removeEventListener(listeners);
  });
};

//

const mapProvide = Vue__default['default'].observable({map: null, toolSet: new Set()});

var script$s = {
  name: 'MtMap',
  mixins: [options],
  provide() {
    return {
      mapProvide,
    }
  },
  props: {
    center: {
      type: [Object, Array],
      default: () => [0, 0],
      custom: true
    },
    zoom: {
      type: Number,
      default: 0,
      custom: true
    },
    baseLayer: {
      type: Object,
      default: null
    },
    minZoom: {
      type: Number,
      default: null
    },
    maxZoom: {
      type: Number,
      default: null
    },
    spatialReference: {
      type: Object,
      default: null
    },
    maxExtent: {
      type: Object,
      default: null
    },
    centerCross: {
      type: Boolean,
      default: false
    },
    seamlessZoom: {
      type: Boolean,
      default: false
    },
    zoomInCenter: {
      type: Boolean,
      default: true
    },
    zoomOrigin: {
      type: Array,
      default: null
    },
    zoomAnimation: {
      type: Boolean,
      default: true
    },
    zoomAnimationDuration: {
      type: Number,
      default: 330
    },
    panAnimation: {
      type: Boolean,
      default: true
    },
    panAnimationDuration: {
      type: Number,
      default: 600
    },
    zoomable: {
      type: Boolean,
      default: true
    },
    enableInfoWindow: {
      type: Boolean,
      default: true
    },
    hitDetect: {
      type: Boolean,
      default: true
    },
    hitDetectLimit: {
      type: Number,
      default: 5
    },
    fpsOnInteracting: {
      type: Number,
      default: 25
    },
    layerCanvasLimitOnInteracting: {
      type: Number,
      default: -1
    },
    fixCenterOnResize: {
      type: Boolean,
      default: true
    },
    maxPitch: {
      type: Number,
      default: 80
    },
    maxVisualPitch: {
      type: Number,
      default: 70
    },
    viewHistory: {
      type: Boolean,
      default: true
    },
    viewHistoryCount: {
      type: Number,
      default: 10
    },
    draggable: {
      type: Boolean,
      default: true,
    },
    dragPan: {
      type: Boolean,
      default: true,
    },
    dragRotate: {
      type: Boolean,
      default: true,
    },
    dragPitch: {
      type: Boolean,
      default: true,
    },
    dragRotatePitch: {
      type: Boolean,
      default: true,
    },
    touchGesture: {
      type: Boolean,
      default: true,
    },
    touchZoom: {
      type: Boolean,
      default: true,
    },
    touchRotate: {
      type: Boolean,
      default: true,
    },
    touchPitch: {
      type: Boolean,
      default: true,
    },
    touchZoomRotate: {
      type: Boolean,
      default: false,
    },
    doubleClickZoom: {
      type: Boolean,
      default: true,
    },
    scrollWheelZoom: {
      type: Boolean,
      default: true,
    },
    geometryEvents: {
      type: Boolean,
      default: true,
    },
    control: {
      type: Boolean,
      default: true,
    },
    attribution: {
      type: [Object, Boolean],
      default: true,
    },
    zoomControl: {
      type: [Object, Boolean],
      default: false,
    },
    scaleControl: {
      type: [Object, Boolean],
      default: false,
    },
    overviewControl: {
      type: [Object, Boolean],
      default: false,
    },
    fog: {
      type: Boolean,
      default: true,
    },
    fogColor: {
      type: Array,
      default: () => [233, 233, 233]
    },
    renderer: {
      type: String,
      default: 'canvas'
    },
    devicePixelRatio: {
      type: Number,
      default: null
    }
  },
  data() {
    return {
      ready: false,
      map: null
    }
  },
  computed: {
    mergeOptions() {
      return mergeProps(this);
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.generateMap();
    });
  },
  beforeDestroy() {
    this.map.remove();
  },
  methods: {
    getMap() {
      return this.map;
    },

    generateMap() {
      if (this.map) {
        this.map.remove();
      }

      this.map = new maptalks.Map(this.$refs.map, mergeProps(this));

      bindEvent(this.map, this, ['ready', 'update:center', 'update:zoom']);
      watchProps(this, this.map, undefined, this.mergeOptions);

      this.map.addEventListener('moving', this.mapMove);
      this.map.addEventListener('zoomend', this.mapZoom);

      this.ready = true;
      mapProvide.map = this.map;
      this.$emit('ready', this.map);
    },

    setCenter(val, oldVal) {
      if (!val) return;
      const newCenter = new maptalks.Coordinate(val);
      const oldCenter = new maptalks.Coordinate(oldVal);

      if (newCenter.x !== oldCenter.x || newCenter.y !== oldCenter.y) {
        this.map.setCenter(newCenter);
      }
    },

    mapMove() {
      let center = this.map.getCenter();
      if (Array.isArray(this.center)) {
        center = [this.map.getCenter().x, this.map.getCenter().y];
      }
      this.$emit('update:center', center);
    },

    mapZoom() {
      this.$emit('update:zoom', this.map.getZoom());
    },

    setZoom(val, oldVal) {
      if (!val) return;
      if (val !== oldVal) {
        this.map.setZoom(val);
      }
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__$s = script$s;

/* template */
var __vue_render__$s = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "div",
    { staticClass: "mt-map" },
    [
      _c("div", { ref: "map", staticClass: "mt-map__instance" }),
      _vm._v(" "),
      _vm.ready ? _vm._t("default") : _vm._e()
    ],
    2
  )
};
var __vue_staticRenderFns__$s = [];
__vue_render__$s._withStripped = true;

  /* style */
  const __vue_inject_styles__$s = function (inject) {
    if (!inject) return
    inject("data-v-7f4c73a0_0", { source: "\n.mt-map {\r\n  width: 100%;\r\n  height: 100%;\n}\n.mt-map__instance {\r\n  width: 100%;\r\n  height: 100%;\r\n  position: relative;\n}\r\n", map: {"version":3,"sources":["E:\\open-source\\vue2-maptalks\\src\\libs\\MtMap.vue"],"names":[],"mappings":";AAuSA;EACA,WAAA;EACA,YAAA;AACA;AAEA;EACA,WAAA;EACA,YAAA;EACA,kBAAA;AACA","file":"MtMap.vue","sourcesContent":["<template>\r\n  <div class=\"mt-map\">\r\n    <div ref=\"map\" class=\"mt-map__instance\"></div>\r\n    <slot v-if=\"ready\"></slot>\r\n  </div>\r\n</template>\r\n\r\n<script>\r\nimport Vue from 'vue';\r\nimport { Map, Coordinate } from 'maptalks';\r\n\r\nimport options from \"../mixins/options\";\r\nimport { bindEvent, mergeProps, watchProps } from \"../utils\";\r\n\r\nconst mapProvide = Vue.observable({map: null, toolSet: new Set()});\r\n\r\nexport default {\r\n  name: 'MtMap',\r\n  mixins: [options],\r\n  provide() {\r\n    return {\r\n      mapProvide,\r\n    }\r\n  },\r\n  props: {\r\n    center: {\r\n      type: [Object, Array],\r\n      default: () => [0, 0],\r\n      custom: true\r\n    },\r\n    zoom: {\r\n      type: Number,\r\n      default: 0,\r\n      custom: true\r\n    },\r\n    baseLayer: {\r\n      type: Object,\r\n      default: null\r\n    },\r\n    minZoom: {\r\n      type: Number,\r\n      default: null\r\n    },\r\n    maxZoom: {\r\n      type: Number,\r\n      default: null\r\n    },\r\n    spatialReference: {\r\n      type: Object,\r\n      default: null\r\n    },\r\n    maxExtent: {\r\n      type: Object,\r\n      default: null\r\n    },\r\n    centerCross: {\r\n      type: Boolean,\r\n      default: false\r\n    },\r\n    seamlessZoom: {\r\n      type: Boolean,\r\n      default: false\r\n    },\r\n    zoomInCenter: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    zoomOrigin: {\r\n      type: Array,\r\n      default: null\r\n    },\r\n    zoomAnimation: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    zoomAnimationDuration: {\r\n      type: Number,\r\n      default: 330\r\n    },\r\n    panAnimation: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    panAnimationDuration: {\r\n      type: Number,\r\n      default: 600\r\n    },\r\n    zoomable: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    enableInfoWindow: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    hitDetect: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    hitDetectLimit: {\r\n      type: Number,\r\n      default: 5\r\n    },\r\n    fpsOnInteracting: {\r\n      type: Number,\r\n      default: 25\r\n    },\r\n    layerCanvasLimitOnInteracting: {\r\n      type: Number,\r\n      default: -1\r\n    },\r\n    fixCenterOnResize: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    maxPitch: {\r\n      type: Number,\r\n      default: 80\r\n    },\r\n    maxVisualPitch: {\r\n      type: Number,\r\n      default: 70\r\n    },\r\n    viewHistory: {\r\n      type: Boolean,\r\n      default: true\r\n    },\r\n    viewHistoryCount: {\r\n      type: Number,\r\n      default: 10\r\n    },\r\n    draggable: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    dragPan: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    dragRotate: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    dragPitch: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    dragRotatePitch: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    touchGesture: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    touchZoom: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    touchRotate: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    touchPitch: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    touchZoomRotate: {\r\n      type: Boolean,\r\n      default: false,\r\n    },\r\n    doubleClickZoom: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    scrollWheelZoom: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    geometryEvents: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    control: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    attribution: {\r\n      type: [Object, Boolean],\r\n      default: true,\r\n    },\r\n    zoomControl: {\r\n      type: [Object, Boolean],\r\n      default: false,\r\n    },\r\n    scaleControl: {\r\n      type: [Object, Boolean],\r\n      default: false,\r\n    },\r\n    overviewControl: {\r\n      type: [Object, Boolean],\r\n      default: false,\r\n    },\r\n    fog: {\r\n      type: Boolean,\r\n      default: true,\r\n    },\r\n    fogColor: {\r\n      type: Array,\r\n      default: () => [233, 233, 233]\r\n    },\r\n    renderer: {\r\n      type: String,\r\n      default: 'canvas'\r\n    },\r\n    devicePixelRatio: {\r\n      type: Number,\r\n      default: null\r\n    }\r\n  },\r\n  data() {\r\n    return {\r\n      ready: false,\r\n      map: null\r\n    }\r\n  },\r\n  computed: {\r\n    mergeOptions() {\r\n      return mergeProps(this);\r\n    }\r\n  },\r\n  mounted() {\r\n    this.$nextTick(() => {\r\n      this.generateMap();\r\n    })\r\n  },\r\n  beforeDestroy() {\r\n    this.map.remove();\r\n  },\r\n  methods: {\r\n    getMap() {\r\n      return this.map;\r\n    },\r\n\r\n    generateMap() {\r\n      if (this.map) {\r\n        this.map.remove()\r\n      }\r\n\r\n      this.map = new Map(this.$refs.map, mergeProps(this));\r\n\r\n      bindEvent(this.map, this, ['ready', 'update:center', 'update:zoom']);\r\n      watchProps(this, this.map, undefined, this.mergeOptions);\r\n\r\n      this.map.addEventListener('moving', this.mapMove);\r\n      this.map.addEventListener('zoomend', this.mapZoom);\r\n\r\n      this.ready = true;\r\n      mapProvide.map = this.map;\r\n      this.$emit('ready', this.map);\r\n    },\r\n\r\n    setCenter(val, oldVal) {\r\n      if (!val) return;\r\n      const newCenter = new Coordinate(val);\r\n      const oldCenter = new Coordinate(oldVal);\r\n\r\n      if (newCenter.x !== oldCenter.x || newCenter.y !== oldCenter.y) {\r\n        this.map.setCenter(newCenter)\r\n      }\r\n    },\r\n\r\n    mapMove() {\r\n      let center = this.map.getCenter();\r\n      if (Array.isArray(this.center)) {\r\n        center = [this.map.getCenter().x, this.map.getCenter().y];\r\n      }\r\n      this.$emit('update:center', center);\r\n    },\r\n\r\n    mapZoom() {\r\n      this.$emit('update:zoom', this.map.getZoom());\r\n    },\r\n\r\n    setZoom(val, oldVal) {\r\n      if (!val) return;\r\n      if (val !== oldVal) {\r\n        this.map.setZoom(val)\r\n      }\r\n    }\r\n  }\r\n}\r\n</script>\r\n\r\n<style>\r\n.mt-map {\r\n  width: 100%;\r\n  height: 100%;\r\n}\r\n\r\n.mt-map__instance {\r\n  width: 100%;\r\n  height: 100%;\r\n  position: relative;\r\n}\r\n</style>\r\n"]}, media: undefined });

  };
  /* scoped */
  const __vue_scope_id__$s = undefined;
  /* module identifier */
  const __vue_module_identifier__$s = undefined;
  /* functional template */
  const __vue_is_functional_template__$s = false;
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$s = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$s, staticRenderFns: __vue_staticRenderFns__$s },
    __vue_inject_styles__$s,
    __vue_script__$s,
    __vue_scope_id__$s,
    __vue_is_functional_template__$s,
    __vue_module_identifier__$s,
    false,
    createInjector,
    undefined,
    undefined
  );

var map = {
  inject: ['mapProvide'],
  computed: {
    map: function map() {
      return this.mapProvide && this.mapProvide.map;
    }
  }
};

var layer = {
  props: {
    id: {
      type: [String, Number],
      required: true
    },
    attribution: {
      type: String,
      default: null
    },
    minZoom: {
      type: Number,
      default: null
    },
    maxZoom: {
      type: Number,
      default: null
    },
    visible: {
      type: Boolean,
      default: true,
      custom: true
    },
    opacity: {
      type: Number,
      default: 1
    },
    zIndex: {
      type: Number,
      default: null
    },
    hitDetect: {
      type: Boolean,
      default: true
    },
    globalCompositeOperation: {
      type: String,
      default: null
    },
    debugOutline: {
      type: String,
      default: '#0f0'
    },
    cssFilter: {
      type: String,
      default: null
    },
    forceRenderOnMoving: {
      type: Boolean,
      default: false
    },
    forceRenderOnZooming: {
      type: Boolean,
      default: false
    },
    forceRenderOnRotating: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    mergeOptions: function mergeOptions() {
      return mergeProps(this);
    }
  },
  data: function data() {
    return {
      layer: null
    };
  },
  methods: {
    setVisible: function setVisible(val) {
      if (val && this.layer) {
        this.layer.show();
      }

      if (!val && this.layer) {
        this.layer.hide();
      }
    },
    getLayer: function getLayer() {
      return this.layer;
    },
    getMap: function getMap() {
      return this.map;
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.layer) {
      this.layer.remove();
    }
  }
};

//

var script$r = {
  name: 'MtTileLayer',
  mixins: [options, map, layer],
  props: {
    urlTemplate: {
      type: [String, Function],
      required: true,
    },
    subdomains: {
      type: Array,
      default: null
    },
    spatialReference: {
      type: Object,
      default: null
    },
    tileSize: {
      type: Array,
      default: () => [256, 256]
    },
    offset: {
      type: [Array, Function],
      default: () => [0, 0]
    },
    tileSystem: {
      type: Array,
      default: null
    },
    maxAvailableZoom: {
      type: Number,
      default: null
    },
    repeatWorld: {
      type: Boolean,
      default: true
    },
    background: {
      type: Boolean,
      default: true
    },
    backgroundZoomDiff: {
      type: Number,
      default: 6
    },
    placeholder: {
      type: [Boolean, Function],
      default: false
    },
    fragmentShader: {
      type: String,
      default: null
    },
    fadeAnimation: {
      type: Boolean,
      default: true
    },
    debug: {
      type: Boolean,
      default: false
    },
    maxCacheSize: {
      type: Number,
      default: 256
    },
    cascadeTiles: {
      type: Boolean,
      default: true
    },
    zoomOffset: {
      type: Number,
      default: 0
    },
    tileRetryCount: {
      type: Number,
      default: 0
    },
    crossOrigin: {
      type: String,
      default: null
    },
    renderer: {
      type: String,
      default: 'gl'
    },
  },
  mounted() {
    this.generateLayer();
  },
  methods: {
    generateLayer() {
      if (!this.id) throw new Error('layer id can not be null');
      if (!this.urlTemplate) throw new Error('tile-layer urlTemplate can not be null');

      if (this.map.getLayer(this.id)) {
        return this.layer = this.map.getLayer(this.id);
      }

      this.layer = new maptalks.TileLayer(this.id, omit(mergeProps(this), 'id'));
      bindEvent(this.layer, this, ['ready']);
      watchProps(this, this.layer, undefined, this.mergeOptions);

      this.layer.addTo(this.map);
      this.$emit('ready', this.layer, this.map);
    }
  }
};

/* script */
const __vue_script__$r = script$r;

/* template */
var __vue_render__$r = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$r = [];
__vue_render__$r._withStripped = true;

  /* style */
  const __vue_inject_styles__$r = undefined;
  /* scoped */
  const __vue_scope_id__$r = undefined;
  /* module identifier */
  const __vue_module_identifier__$r = undefined;
  /* functional template */
  const __vue_is_functional_template__$r = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$r = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$r, staticRenderFns: __vue_staticRenderFns__$r },
    __vue_inject_styles__$r,
    __vue_script__$r,
    __vue_scope_id__$r,
    __vue_is_functional_template__$r,
    __vue_module_identifier__$r,
    false,
    undefined,
    undefined,
    undefined
  );

//

const vectorLayerProvide = Vue__default['default'].observable({layer: null});

var script$q = {
  name: 'MtVectorLayer',
  mixins: [map, options, layer],
  provide() {
    return {
      vectorLayerProvide
    }
  },
  props: {
    geometries: {
      type: [Array, Object],
      default: null,
      custom: true
    },
    debug: {
      type: Boolean,
      default: false
    },
    cursor: {
      type: String,
      default: null
    },
    enableSimplify: {
      type: Boolean,
      default: true
    },
    geometryEvents: {
      type: Boolean,
      default: true
    },
    defaultIconSize: {
      type: Array,
      default: () => [20, 20]
    },
    enableAltitude: {
      type: Boolean,
      default: false
    },

    altitudeProperty: {
      type: String,
      default: 'altitude'
    },
    drawAltitude: {
      type: Boolean,
      default: false
    },
    altitude: {
      type: Number,
      default: 0
    },
    drawImmediate: {
      type: Boolean,
      default: false
    },
    renderer: {
      type: String,
      default: 'canvas'
    },
  },
  watch: {
    geometries: {
      handler(val) {
        if (JSON.stringify(val) !== JSON.stringify(this.layer.getGeometries()) && this.layer) {
          this.layer.clear();

          this.addGeometries(val);
        }
      }
    }
  },
  mounted() {
    this.generateLayer();
  },
  methods: {
    generateLayer() {
      if (!this.id) throw new Error('layer id can not be null');

      if (this.map.getLayer(this.id)) {
        return this.layer = this.map.getLayer(this.id);
      }

      this.layer = new maptalks.VectorLayer(this.id, this.geometries, omit(mergeProps(this), ['id', 'geometries']));
      bindEvent(this.layer, this, ['ready']);
      watchProps(this, this.layer, 'geometries', this.mergeOptions);

      vectorLayerProvide.layer = this.layer;
      this.layer.addTo(this.map);
      this.$emit('ready', this.layer, this.map);
    },
    addGeometries(val) {
      if (Array.isArray(val)) {
        val.forEach(geometry => {
          bindEvent(geometry, this, []);
        });
      } else if (val) {
        bindEvent(val, this, []);
      }

      this.layer.addGeometry(val);
    }
  }
};

/* script */
const __vue_script__$q = script$q;

/* template */
var __vue_render__$q = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.layer ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$q = [];
__vue_render__$q._withStripped = true;

  /* style */
  const __vue_inject_styles__$q = undefined;
  /* scoped */
  const __vue_scope_id__$q = undefined;
  /* module identifier */
  const __vue_module_identifier__$q = undefined;
  /* functional template */
  const __vue_is_functional_template__$q = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$q = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$q, staticRenderFns: __vue_staticRenderFns__$q },
    __vue_inject_styles__$q,
    __vue_script__$q,
    __vue_scope_id__$q,
    __vue_is_functional_template__$q,
    __vue_module_identifier__$q,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$p = {
  name: 'MtWmsLayer',
  mixins: [map, layer, options],
  props: {
    urlTemplate: {
      type: [String, Function],
      required: true,
    },
    layers: {
      type: String,
      default: null
    },
    styles: {
      type: String,
      default: ''
    },
    format: {
      type: String,
      default: 'image/jpeg'
    },
    transparent: {
      type: Boolean,
      default: false
    },
    version: {
      type: String,
      default: '1.1.1'
    },
    crs: {
      type: String,
      default: null
    },
    uppercase: {
      type: Boolean,
      default: false
    },
    detectRetina: {
      type: Boolean,
      default: false
    },
    subdomains: {
      type: Array,
      default: null
    },
    spatialReference: {
      type: Object,
      default: null
    },
    tileSize: {
      type: Array,
      default: () => [256, 256]
    },
    offset: {
      type: [Array, Function],
      default: () => [0, 0]
    },
    tileSystem: {
      type: Array,
      default: null
    },
    maxAvailableZoom: {
      type: Number,
      default: null
    },
    repeatWorld: {
      type: Boolean,
      default: true
    },
    background: {
      type: Boolean,
      default: true
    },
    backgroundZoomDiff: {
      type: Number,
      default: 6
    },
    placeholder: {
      type: [Boolean, Function],
      default: false
    },
    fragmentShader: {
      type: String,
      default: null
    },
    crossOrigin: {
      type: String,
      default: null
    },
    fadeAnimation: {
      type: Boolean,
      default: true
    },
    debug: {
      type: Boolean,
      default: false
    },
    renderer: {
      type: String,
      default: 'gl'
    },
    maxCacheSize: {
      type: Number,
      default: 256
    },
    cascadeTiles: {
      type: Boolean,
      default: true
    },
    zoomOffset: {
      type: Number,
      default: 0
    },
    tileRetryCount: {
      type: Number,
      default: 0
    },
  },
  mounted() {
    this.generateLayer();
  },
  methods: {
    generateLayer() {
      if (!this.id) throw new Error('layer id can not be null');
      if (!this.urlTemplate) throw new Error('Wms-Layer urlTemplate can not be null');

      if (this.map.getLayer(this.id)) {
        return this.layer = this.map.getLayer(this.id);
      }

      this.layer = new maptalks.WMSTileLayer(this.id, omit(mergeProps(this), 'id'));
      bindEvent(this.layer, this, ['ready']);
      watchProps(this, this.layer, undefined, this.mergeOptions);

      this.layer.addTo(this.map);
      this.$emit('ready', this.layer, this.map);
    }
  }
};

/* script */
const __vue_script__$p = script$p;

/* template */
var __vue_render__$p = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$p = [];
__vue_render__$p._withStripped = true;

  /* style */
  const __vue_inject_styles__$p = undefined;
  /* scoped */
  const __vue_scope_id__$p = undefined;
  /* module identifier */
  const __vue_module_identifier__$p = undefined;
  /* functional template */
  const __vue_is_functional_template__$p = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$p = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$p, staticRenderFns: __vue_staticRenderFns__$p },
    __vue_inject_styles__$p,
    __vue_script__$p,
    __vue_scope_id__$p,
    __vue_is_functional_template__$p,
    __vue_module_identifier__$p,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$o = {
  name: 'MtImageLayer',
  mixins: [map, layer, options],
  props: {
    images: {
      type: Array,
      default: null
    },
    crossOrigin: {
      type: String,
      default: null
    },
    renderer: {
      type: String,
      default: 'gl'
    },
  },
  mounted() {
    this.generateLayer();
  },
  methods: {
    generateLayer() {
      if (!this.id) throw new Error('layer id can not be null');

      if (this.map.getLayer(this.id)) {
        return this.layer = this.map.getLayer(this.id);
      }

      this.layer = new maptalks.ImageLayer(this.id, this.images, omit(mergeProps(this), ['id', 'images']));
      bindEvent(this.layer, this, ['ready']);
      watchProps(this, this.layer, undefined, this.mergeOptions);

      this.layer.addTo(this.map);
      this.$emit('ready', this.layer, this.map);
    }
  }
};

/* script */
const __vue_script__$o = script$o;

/* template */
var __vue_render__$o = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$o = [];
__vue_render__$o._withStripped = true;

  /* style */
  const __vue_inject_styles__$o = undefined;
  /* scoped */
  const __vue_scope_id__$o = undefined;
  /* module identifier */
  const __vue_module_identifier__$o = undefined;
  /* functional template */
  const __vue_is_functional_template__$o = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$o = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$o, staticRenderFns: __vue_staticRenderFns__$o },
    __vue_inject_styles__$o,
    __vue_script__$o,
    __vue_scope_id__$o,
    __vue_is_functional_template__$o,
    __vue_module_identifier__$o,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$n = {
  name: 'MtParticleLayer',
  mixins: [map, options, layer],
  props: {
    animation: {
      type: Boolean,
      default: true
    },
    doubleBuffer: {
      type: Boolean,
      default: true
    },
    getParticles: {
      type: Function,
      default: () => {}
    },
    fps: {
      type: Number,
      default: 1000 / 16
    },
    renderer: {
      type: String,
      default: 'canvas'
    },
  },
  mounted() {
    this.generateLayer();
  },
  methods: {
    generateLayer() {
      if (!this.id) throw new Error('layer id can not be null');

      if (this.map.getLayer(this.id)) {
        return this.layer = this.map.getLayer(this.id);
      }

      this.layer = new maptalks.ParticleLayer(this.id, omit(mergeProps(this), ['id', 'getParticles']));
      bindEvent(this.layer, this, ['ready']);
      watchProps(this, this.layer, 'getParticles', this.mergeOptions);

      this.layer.getParticles = this.getParticles;

      this.layer.addTo(this.map);
      this.$emit('ready', this.layer, this.map);
    },
  }
};

/* script */
const __vue_script__$n = script$n;

/* template */
var __vue_render__$n = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$n = [];
__vue_render__$n._withStripped = true;

  /* style */
  const __vue_inject_styles__$n = undefined;
  /* scoped */
  const __vue_scope_id__$n = undefined;
  /* module identifier */
  const __vue_module_identifier__$n = undefined;
  /* functional template */
  const __vue_is_functional_template__$n = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$n = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$n, staticRenderFns: __vue_staticRenderFns__$n },
    __vue_inject_styles__$n,
    __vue_script__$n,
    __vue_scope_id__$n,
    __vue_is_functional_template__$n,
    __vue_module_identifier__$n,
    false,
    undefined,
    undefined,
    undefined
  );

var geometry = {
  inject: ['vectorLayerProvide'],
  props: {
    id: {
      type: [String, Number],
      default: null
    },
    visible: {
      type: Boolean,
      default: true,
      custom: true
    },
    editable: {
      type: Boolean,
      default: true
    },
    interactive: {
      type: Boolean,
      default: true
    },
    cursor: {
      type: String,
      default: null
    },
    measure: {
      type: String,
      default: 'EPSG:4326'
    },
    draggable: {
      type: String,
      default: null
    },
    dragShadow: {
      type: Boolean,
      default: true
    },
    dragOnAxis: {
      type: [Boolean, String],
      default: null
    },
    zIndex: {
      type: Number,
      default: null
    }
  },
  computed: {
    layer: function layer() {
      return this.vectorLayerProvide && this.vectorLayerProvide.layer;
    },
    mergeOptions: function mergeOptions() {
      return mergeProps(this);
    }
  },
  data: function data() {
    return {
      geometry: null,
      ready: false
    };
  },
  methods: {
    setVisible: function setVisible(val) {
      if (val && this.geometry) {
        this.geometry.show();
      }

      if (!val && this.geometry) {
        this.geometry.hide();
      }
    },
    getLayer: function getLayer() {
      return this.layer;
    },
    getMap: function getMap() {
      return this.map;
    },
    getGeometry: function getGeometry() {
      return this.geometry;
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.geometry) {
      this.geometry.remove();
    }
  }
};

//

var script$m = {
  name: 'MtMarker',
  mixins: [map, geometry, options],
  props: {
    coordinates: {
      type: [Array, Object],
      default: null
    },
    symbol: {
      type: Object,
      default: null
    },
    properties: {
      type: Object,
      default: null
    }
  },
  computed: {
    mergeOptions() {
      return mergeProps(this);
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!this.coordinates) throw new Error('marker coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Marker(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$m = script$m;

/* template */
var __vue_render__$m = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$m = [];
__vue_render__$m._withStripped = true;

  /* style */
  const __vue_inject_styles__$m = undefined;
  /* scoped */
  const __vue_scope_id__$m = undefined;
  /* module identifier */
  const __vue_module_identifier__$m = undefined;
  /* functional template */
  const __vue_is_functional_template__$m = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$m = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$m, staticRenderFns: __vue_staticRenderFns__$m },
    __vue_inject_styles__$m,
    __vue_script__$m,
    __vue_scope_id__$m,
    __vue_is_functional_template__$m,
    __vue_module_identifier__$m,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$l = {
  name: 'MtLabel',
  mixins: [map, options, geometry]
};

/* script */
const __vue_script__$l = script$l;

/* template */
var __vue_render__$l = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$l = [];
__vue_render__$l._withStripped = true;

  /* style */
  const __vue_inject_styles__$l = undefined;
  /* scoped */
  const __vue_scope_id__$l = undefined;
  /* module identifier */
  const __vue_module_identifier__$l = undefined;
  /* functional template */
  const __vue_is_functional_template__$l = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$l = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$l, staticRenderFns: __vue_staticRenderFns__$l },
    __vue_inject_styles__$l,
    __vue_script__$l,
    __vue_scope_id__$l,
    __vue_is_functional_template__$l,
    __vue_module_identifier__$l,
    false,
    undefined,
    undefined,
    undefined
  );

var path = {
  props: {
    smoothness: {
      type: Number,
      default: 0
    },
    enableSimplify: {
      type: Boolean,
      default: true
    },
    simplifyTolerance: {
      type: Number,
      default: 2
    },
    enableClip: {
      type: Boolean,
      default: true
    },
    symbol: {
      type: Object
    }
  }
};

//

var script$k = {
  name: 'MtLineString',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    },
    arrowStyle: {
      type: [String, Array],
      default: null
    },
    arrowPlacement: {
      type: String,
      default: 'vertex-last'
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('polygon coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.LineString(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$k = script$k;

/* template */
var __vue_render__$k = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$k = [];
__vue_render__$k._withStripped = true;

  /* style */
  const __vue_inject_styles__$k = undefined;
  /* scoped */
  const __vue_scope_id__$k = undefined;
  /* module identifier */
  const __vue_module_identifier__$k = undefined;
  /* functional template */
  const __vue_is_functional_template__$k = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$k = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$k, staticRenderFns: __vue_staticRenderFns__$k },
    __vue_inject_styles__$k,
    __vue_script__$k,
    __vue_scope_id__$k,
    __vue_is_functional_template__$k,
    __vue_module_identifier__$k,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$j = {
  name: 'MtPolygon',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('polygon coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Polygon(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$j = script$j;

/* template */
var __vue_render__$j = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$j = [];
__vue_render__$j._withStripped = true;

  /* style */
  const __vue_inject_styles__$j = undefined;
  /* scoped */
  const __vue_scope_id__$j = undefined;
  /* module identifier */
  const __vue_module_identifier__$j = undefined;
  /* functional template */
  const __vue_is_functional_template__$j = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$j = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$j, staticRenderFns: __vue_staticRenderFns__$j },
    __vue_inject_styles__$j,
    __vue_script__$j,
    __vue_scope_id__$j,
    __vue_is_functional_template__$j,
    __vue_module_identifier__$j,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$i = {
  name: 'MtCircle',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: Array,
      required: true
    },
    radius: {
      type: Number,
      required: true
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('rectangle coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Circle(this.coordinates, this.radius, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$i = script$i;

/* template */
var __vue_render__$i = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$i = [];
__vue_render__$i._withStripped = true;

  /* style */
  const __vue_inject_styles__$i = undefined;
  /* scoped */
  const __vue_scope_id__$i = undefined;
  /* module identifier */
  const __vue_module_identifier__$i = undefined;
  /* functional template */
  const __vue_is_functional_template__$i = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$i = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$i, staticRenderFns: __vue_staticRenderFns__$i },
    __vue_inject_styles__$i,
    __vue_script__$i,
    __vue_scope_id__$i,
    __vue_is_functional_template__$i,
    __vue_module_identifier__$i,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$h = {
  name: 'MtEllipse',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: [Array, Object],
      required: true
    },
    width: {
      type: Number,
      required: true
    },
    height: {
      type: Number,
      required: true
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!this.coordinates) throw new Error('ellipse coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Ellipse(this.coordinates, this.width, this.height, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$h = script$h;

/* template */
var __vue_render__$h = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$h = [];
__vue_render__$h._withStripped = true;

  /* style */
  const __vue_inject_styles__$h = undefined;
  /* scoped */
  const __vue_scope_id__$h = undefined;
  /* module identifier */
  const __vue_module_identifier__$h = undefined;
  /* functional template */
  const __vue_is_functional_template__$h = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$h = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$h, staticRenderFns: __vue_staticRenderFns__$h },
    __vue_inject_styles__$h,
    __vue_script__$h,
    __vue_scope_id__$h,
    __vue_is_functional_template__$h,
    __vue_module_identifier__$h,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$g = {
  name: 'MtRectangle',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: [Array, Object],
      default: null
    },
    width: {
      type: Number,
      required: true,
    },
    height: {
      type: Number,
      required: true
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!this.coordinates) throw new Error('rectangle coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Rectangle(this.coordinates, this.width, this.height, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$g = script$g;

/* template */
var __vue_render__$g = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$g = [];
__vue_render__$g._withStripped = true;

  /* style */
  const __vue_inject_styles__$g = undefined;
  /* scoped */
  const __vue_scope_id__$g = undefined;
  /* module identifier */
  const __vue_module_identifier__$g = undefined;
  /* functional template */
  const __vue_is_functional_template__$g = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$g = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$g, staticRenderFns: __vue_staticRenderFns__$g },
    __vue_inject_styles__$g,
    __vue_script__$g,
    __vue_scope_id__$g,
    __vue_is_functional_template__$g,
    __vue_module_identifier__$g,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$f = {
  name: 'MtSector',
  mixins: [map, geometry, path, options],
  props: {
    coordinates: {
      type: Array,
      required: true
    },
    radius: {
      type: Number,
      required: true
    },
    startAngle: {
      type: Number,
      required: true
    },
    endAngle: {
      type: Number,
      required: true
    },
    numberOfShellPoints: {
      type: Number,
      default: 60
    },
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!this.coordinates) throw new Error('sector coordinates can not be empty');

      if (this.id && this.layer.getGeometryById(this.id)) {
        this.geometry = this.layer.getGeometryById(this.id);
        return;
      }

      this.geometry = new maptalks.Sector(this.coordinates, this.radius, this.startAngle, this.endAngle, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$f = script$f;

/* template */
var __vue_render__$f = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div", [_vm._t("default")], 2) : _vm._e()
};
var __vue_staticRenderFns__$f = [];
__vue_render__$f._withStripped = true;

  /* style */
  const __vue_inject_styles__$f = undefined;
  /* scoped */
  const __vue_scope_id__$f = undefined;
  /* module identifier */
  const __vue_module_identifier__$f = undefined;
  /* functional template */
  const __vue_is_functional_template__$f = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$f = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$f, staticRenderFns: __vue_staticRenderFns__$f },
    __vue_inject_styles__$f,
    __vue_script__$f,
    __vue_scope_id__$f,
    __vue_is_functional_template__$f,
    __vue_module_identifier__$f,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$e = {
  name: 'MtMultiPoint',
  mixins: [map, geometry, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    },
    symbol: {
      type: Object,
      default: null
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('multi-point coordinates can not be empty');

      this.geometry = new maptalks.MultiPoint(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$e = script$e;

/* template */
var __vue_render__$e = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div") : _vm._e()
};
var __vue_staticRenderFns__$e = [];
__vue_render__$e._withStripped = true;

  /* style */
  const __vue_inject_styles__$e = undefined;
  /* scoped */
  const __vue_scope_id__$e = undefined;
  /* module identifier */
  const __vue_module_identifier__$e = undefined;
  /* functional template */
  const __vue_is_functional_template__$e = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$e = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$e, staticRenderFns: __vue_staticRenderFns__$e },
    __vue_inject_styles__$e,
    __vue_script__$e,
    __vue_scope_id__$e,
    __vue_is_functional_template__$e,
    __vue_module_identifier__$e,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$d = {
  name: 'MtMultiLineString',
  mixins: [map, geometry, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    },
    symbol: {
      type: Object,
      default: null
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('multi-line-string coordinates can not be empty');

      this.geometry = new maptalks.MultiLineString(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$d = script$d;

/* template */
var __vue_render__$d = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div") : _vm._e()
};
var __vue_staticRenderFns__$d = [];
__vue_render__$d._withStripped = true;

  /* style */
  const __vue_inject_styles__$d = undefined;
  /* scoped */
  const __vue_scope_id__$d = undefined;
  /* module identifier */
  const __vue_module_identifier__$d = undefined;
  /* functional template */
  const __vue_is_functional_template__$d = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$d = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$d, staticRenderFns: __vue_staticRenderFns__$d },
    __vue_inject_styles__$d,
    __vue_script__$d,
    __vue_scope_id__$d,
    __vue_is_functional_template__$d,
    __vue_module_identifier__$d,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$c = {
  name: 'MtMultiPolygon',
  mixins: [map, geometry, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    },
    symbol: {
      type: Object,
      default: null
    }
  },
  mounted() {
    this.generateGeometry();
  },
  methods: {
    generateGeometry() {
      if (!Array.isArray(this.coordinates) || this.coordinates.length === 0) throw new Error('multi-polygon coordinates can not be empty');

      this.geometry = new maptalks.MultiPolygon(this.coordinates, mergeProps(this));
      bindEvent(this.geometry, this, ['ready']);
      watchProps(this, this.geometry, undefined, this.mergeOptions);

      this.geometry.addTo(this.layer);
      this.$emit('ready', this.geometry, this.layer, this.map);

      this.ready = true;
    }
  }
};

/* script */
const __vue_script__$c = script$c;

/* template */
var __vue_render__$c = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.ready ? _c("div") : _vm._e()
};
var __vue_staticRenderFns__$c = [];
__vue_render__$c._withStripped = true;

  /* style */
  const __vue_inject_styles__$c = undefined;
  /* scoped */
  const __vue_scope_id__$c = undefined;
  /* module identifier */
  const __vue_module_identifier__$c = undefined;
  /* functional template */
  const __vue_is_functional_template__$c = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$c = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$c, staticRenderFns: __vue_staticRenderFns__$c },
    __vue_inject_styles__$c,
    __vue_script__$c,
    __vue_scope_id__$c,
    __vue_is_functional_template__$c,
    __vue_module_identifier__$c,
    false,
    undefined,
    undefined,
    undefined
  );

var control = {
  data: function data() {
    return {
      control: null
    };
  },
  computed: {
    mergeOptions: function mergeOptions() {
      return mergeProps(this);
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.control) {
      this.control.remove();
    }
  }
};

//

var script$b = {
  name: 'MtAttribution',
  mixins: [map, options, control],
  props: {
    position: {
      type: [String, Object],
      default: 'top-left'
    },
    content: {
      type: String,
      default: null
    }
  },
  mounted() {
    this.generateControl();
  },

  methods: {
    generateControl() {
      this.control = new maptalks.control.Attribution(mergeProps(this));

      bindEvent(this.control, this, []);
      watchProps(this, this.control, undefined, this.mergeOptions);

      this.control.addTo(this.map);
    }
  }
};

/* script */
const __vue_script__$b = script$b;

/* template */
var __vue_render__$b = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$b = [];
__vue_render__$b._withStripped = true;

  /* style */
  const __vue_inject_styles__$b = undefined;
  /* scoped */
  const __vue_scope_id__$b = undefined;
  /* module identifier */
  const __vue_module_identifier__$b = undefined;
  /* functional template */
  const __vue_is_functional_template__$b = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$b = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$b, staticRenderFns: __vue_staticRenderFns__$b },
    __vue_inject_styles__$b,
    __vue_script__$b,
    __vue_scope_id__$b,
    __vue_is_functional_template__$b,
    __vue_module_identifier__$b,
    false,
    undefined,
    undefined,
    undefined
  );

var uiComponent = {
  props: {
    visible: {
      type: Boolean,
      default: true,
      custom: true
    },
    eventsPropagation: {
      type: Boolean,
      default: false
    },
    eventsToStop: {
      type: Boolean,
      default: null
    },
    dx: {
      type: Number,
      default: 0
    },
    dy: {
      type: Number,
      default: 0
    },
    autoPan: {
      type: Boolean,
      default: false
    },
    single: {
      type: Boolean,
      default: true
    },
    animation: {
      type: String,
      default: null
    },
    animationDuration: {
      type: Number,
      default: 300
    },
    pitchWithMap: {
      type: Boolean,
      default: false
    },
    rotateWithMap: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    mergeOptions: function mergeOptions() {
      return mergeProps(this);
    }
  },
  data: function data() {
    return {
      uiComponent: null
    };
  },
  methods: {
    setVisible: function setVisible(val) {
      if (val && this.uiComponent) {
        this.uiComponent.show();
        this.$emit('visible', true);
      }

      if (!val && this.uiComponent) {
        this.uiComponent.hide();
        this.$emit('visible', false);
      }
    },
    showEnd: function showEnd() {
      this.$emit('update:visible', true);
    },
    hide: function hide() {
      this.$emit('update:visible', false);
    },
    setSlotToContent: function setSlotToContent() {
      if (this.$slots.default) {
        this.uiComponent.setContent(this.$el);
      }
    },
    bindVisibleEvent: function bindVisibleEvent() {
      this.uiComponent.addEventListener('showend', this.showEnd);
      this.uiComponent.addEventListener('hide', this.hide);
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.uiComponent) {
      this.uiComponent.remove();
    }
  }
};

//

var script$a = {
  name: 'MtMenu',
  mixins: [map, options, uiComponent],
  props: {
    width: {
      type: Number,
      default: 160
    },
    maxHeight: {
      type: Number,
      default: 0
    },
    custom: {
      type: Boolean,
      default: false
    },
    items: {
      type: Array,
      default: null
    }
  },
  mounted() {
    this.generateControl();
  },
  methods: {
    generateControl() {
      this.uiComponent = new maptalks.ui.Menu(mergeProps(this));
      bindEvent(this.uiComponent, this, []);
      watchProps(this, this.uiComponent, undefined, this.mergeOptions);
      this.addToElement();
    },
    addToElement() {
      if (this.$parent.geometry) {
        this.$parent.geometry.setMenu(this.mergeOptions);
      } else {
        this.map.setMenu(this.mergeOptions);
      }
    }
  }
};

/* script */
const __vue_script__$a = script$a;

/* template */
var __vue_render__$a = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$a = [];
__vue_render__$a._withStripped = true;

  /* style */
  const __vue_inject_styles__$a = undefined;
  /* scoped */
  const __vue_scope_id__$a = undefined;
  /* module identifier */
  const __vue_module_identifier__$a = undefined;
  /* functional template */
  const __vue_is_functional_template__$a = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$a = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$a, staticRenderFns: __vue_staticRenderFns__$a },
    __vue_inject_styles__$a,
    __vue_script__$a,
    __vue_scope_id__$a,
    __vue_is_functional_template__$a,
    __vue_module_identifier__$a,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$9 = {
  name: 'MtOverview',
  mixins: [map, options, control],
  props: {
    position: {
      type: [String, Object],
      default: 'top-right'
    },
    level: {
      type: Number,
      default: 4
    },
    maximize: {
      type: Boolean,
      default: true
    },
    size: {
      type: Array,
      default: () => [300, 200]
    },
    symbol: {
      type: Object,
      default: null
    },
    containerClass: {
      type: [String, Object],
      default: 'maptalks-overview'
    },
    buttonClass: {
      type: [String, Object],
      default: 'maptalks-overview-button'
    }
  },
  mounted() {
    this.generateControl();
  },
  methods: {
    generateControl() {
      this.control = new maptalks.control.Overview(mergeProps(this));

      bindEvent(this.control, this, []);
      watchProps(this, this.control, undefined, this.mergeOptions);

      this.control.addTo(this.map);
    }
  }
};

/* script */
const __vue_script__$9 = script$9;

/* template */
var __vue_render__$9 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$9 = [];
__vue_render__$9._withStripped = true;

  /* style */
  const __vue_inject_styles__$9 = undefined;
  /* scoped */
  const __vue_scope_id__$9 = undefined;
  /* module identifier */
  const __vue_module_identifier__$9 = undefined;
  /* functional template */
  const __vue_is_functional_template__$9 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$9 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$9, staticRenderFns: __vue_staticRenderFns__$9 },
    __vue_inject_styles__$9,
    __vue_script__$9,
    __vue_scope_id__$9,
    __vue_is_functional_template__$9,
    __vue_module_identifier__$9,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$8 = {
  name: 'MtPanel',
  mixins: [map, options, control],
  props: {
    visible: {
      type: Boolean,
      default: true,
      custom: true
    },
    position: {
      type: [String, Object],
      default: 'top-right'
    },
    draggable: {
      type: Boolean,
      default: true
    },
    custom: {
      type: Boolean,
      default: false
    },
    content: {
      type: [String, Object],
      default: null
    },
    closeButton: {
      type: Boolean,
      default: true
    }
  },
  mounted() {
    this.generateControl();
  },
  methods: {
    generateControl() {
      this.control = new maptalks.control.Panel(mergeProps(this));

      if (this.$slots.default) {
        this.control.setContent(this.$el);
      }

      bindEvent(this.control, this, []);
      watchProps(this, this.control, undefined, this.mergeOptions);

      this.control.addTo(this.map);
    },
    setVisible(val) {
      if (val && this.control) {
        this.control.show();
      }
      if (!val && this.control) {
        this.control.hide();
      }
    }
  }
};

/* script */
const __vue_script__$8 = script$8;

/* template */
var __vue_render__$8 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", [_vm._t("default")], 2)
};
var __vue_staticRenderFns__$8 = [];
__vue_render__$8._withStripped = true;

  /* style */
  const __vue_inject_styles__$8 = undefined;
  /* scoped */
  const __vue_scope_id__$8 = undefined;
  /* module identifier */
  const __vue_module_identifier__$8 = undefined;
  /* functional template */
  const __vue_is_functional_template__$8 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$8 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
    __vue_inject_styles__$8,
    __vue_script__$8,
    __vue_scope_id__$8,
    __vue_is_functional_template__$8,
    __vue_module_identifier__$8,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$7 = {
  name: 'MtScale',
  mixins: [map, options, control],
  props: {
    position: {
      type: [String, Object],
      default: 'bottom-left'
    },
    maxWidth: {
      type: Number,
      default: 100
    },
    metric: {
      type: Boolean,
      default: true
    },
    imperial: {
      type: [Boolean, String],
      default: false
    },
    containerClass: {
      type: [String, Object],
      default: null
    }
  },
  mounted() {
    this.generateControl();
  },

  methods: {
    generateControl() {
      this.control = new maptalks.control.Scale(mergeProps(this));

      bindEvent(this.control, this, []);
      watchProps(this, this.control, undefined, this.mergeOptions);

      this.control.addTo(this.map);
    }
  }
};

/* script */
const __vue_script__$7 = script$7;

/* template */
var __vue_render__$7 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$7 = [];
__vue_render__$7._withStripped = true;

  /* style */
  const __vue_inject_styles__$7 = undefined;
  /* scoped */
  const __vue_scope_id__$7 = undefined;
  /* module identifier */
  const __vue_module_identifier__$7 = undefined;
  /* functional template */
  const __vue_is_functional_template__$7 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$7 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
    __vue_inject_styles__$7,
    __vue_script__$7,
    __vue_scope_id__$7,
    __vue_is_functional_template__$7,
    __vue_module_identifier__$7,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//

var script$6 = {
  name: 'MtToolbar'
};

/* script */
const __vue_script__$6 = script$6;

/* template */
var __vue_render__$6 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$6 = [];
__vue_render__$6._withStripped = true;

  /* style */
  const __vue_inject_styles__$6 = undefined;
  /* scoped */
  const __vue_scope_id__$6 = undefined;
  /* module identifier */
  const __vue_module_identifier__$6 = undefined;
  /* functional template */
  const __vue_is_functional_template__$6 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$6 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
    __vue_inject_styles__$6,
    __vue_script__$6,
    __vue_scope_id__$6,
    __vue_is_functional_template__$6,
    __vue_module_identifier__$6,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$5 = {
  name: 'MtZoom',
  mixins: [map, options, control],
  props: {
    position: {
      type: [String, Object],
      default: 'top-left'
    },
    slider: {
      type: Boolean,
      default: true
    },
    zoomLevel: {
      type: Boolean,
      default: true
    }
  },
  mounted() {
    this.generateControl();
  },
  methods: {
    generateControl() {
      this.control = new maptalks.control.Zoom(mergeProps(this));

      bindEvent(this.control, this, []);
      watchProps(this, this.control, undefined, this.mergeOptions);

      this.control.addTo(this.map);
    }
  }
};

/* script */
const __vue_script__$5 = script$5;

/* template */
var __vue_render__$5 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$5 = [];
__vue_render__$5._withStripped = true;

  /* style */
  const __vue_inject_styles__$5 = undefined;
  /* scoped */
  const __vue_scope_id__$5 = undefined;
  /* module identifier */
  const __vue_module_identifier__$5 = undefined;
  /* functional template */
  const __vue_is_functional_template__$5 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$5 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
    __vue_inject_styles__$5,
    __vue_script__$5,
    __vue_scope_id__$5,
    __vue_is_functional_template__$5,
    __vue_module_identifier__$5,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$4 = {
  name: 'MtInfoWindow',
  mixins: [map, uiComponent, options],
  props: {
    coordinates: {
      type: Array,
      default: null
    },
    autoPan: {
      type: Boolean,
      default: null
    },
    autoCloseOn: {
      type: Boolean,
      default: null
    },
    autoOpenOn: {
      type: [Boolean, String],
      default: 'click'
    },
    width: {
      type: Number,
      default: 300
    },
    minHeight: {
      type: Number,
      default: 120
    },
    custom: {
      type: Boolean,
      default: false
    },
    title: {
      type: String,
      default: null
    },
    content: {
      type: [String, Object],
      default: null
    }
  },
  watch: {
    deep: true,
    coordinates: {
      handler() {
        if (!this.$parent.geometry && this.map && this.uiComponent) {
          this.uiComponent.remove();

          this.generateInfoWindow();
        }
      }
    }
  },
  mounted() {
    this.generateInfoWindow();
  },
  methods: {
    generateInfoWindow() {
      this.uiComponent = new maptalks.ui.InfoWindow(mergeProps(this));
      this.setSlotToContent();

      bindEvent(this.uiComponent, this, []);
      watchProps(this, this.uiComponent, undefined, this.mergeOptions);

      this.addInfoWindows();

      this.setVisible(this.visible);
      this.bindVisibleEvent();
    },
    addInfoWindows() {
      if (this.$parent.geometry) {
        this.uiComponent.addTo(this.$parent.geometry);
      } else if (this.map) {
        let coordinates = this.coordinates;
        if (!this.coordinates) {
          coordinates = this.map.getCenter();
        }

        this.uiComponent.addTo(this.map).show(coordinates);
      }
    }
  }
};

/* script */
const __vue_script__$4 = script$4;

/* template */
var __vue_render__$4 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", [_vm._t("default")], 2)
};
var __vue_staticRenderFns__$4 = [];
__vue_render__$4._withStripped = true;

  /* style */
  const __vue_inject_styles__$4 = undefined;
  /* scoped */
  const __vue_scope_id__$4 = undefined;
  /* module identifier */
  const __vue_module_identifier__$4 = undefined;
  /* functional template */
  const __vue_is_functional_template__$4 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$4 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
    __vue_inject_styles__$4,
    __vue_script__$4,
    __vue_scope_id__$4,
    __vue_is_functional_template__$4,
    __vue_module_identifier__$4,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$3 = {
  name: 'MtUMarker',
  mixins: [map, uiComponent, options],
  props: {
    coordinates: {
      type: [Array, Object],
      default: null
    },
    content: {
      type: [String, Object],
      default: null
    }
  },
  mounted() {
    this.generateInfoWindow();
  },
  methods: {
    generateInfoWindow() {
      this.uiComponent = new maptalks.ui.UIMarker(this.coordinates, mergeProps(this));
      this.setSlotToContent();

      bindEvent(this.uiComponent, this, []);
      watchProps(this, this.uiComponent, undefined, this.mergeOptions);

      this.uiComponent.addTo(this.map);
      this.setVisible(this.visible);
      this.bindVisibleEvent();
    }
  }
};

/* script */
const __vue_script__$3 = script$3;

/* template */
var __vue_render__$3 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", [_vm._t("default")], 2)
};
var __vue_staticRenderFns__$3 = [];
__vue_render__$3._withStripped = true;

  /* style */
  const __vue_inject_styles__$3 = undefined;
  /* scoped */
  const __vue_scope_id__$3 = undefined;
  /* module identifier */
  const __vue_module_identifier__$3 = undefined;
  /* functional template */
  const __vue_is_functional_template__$3 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$3 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
    __vue_inject_styles__$3,
    __vue_script__$3,
    __vue_scope_id__$3,
    __vue_is_functional_template__$3,
    __vue_module_identifier__$3,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$2 = {
  name: 'MtDrawTool',
  mixins: [map, options],
  props: {
    enable: {
      type: Boolean,
      default: false,
      custom: true
    },
    mode: {
      type: String,
      default: 'Point' // Point | LineString | Polygon | Circle | Ellipse | Rectangle | FreeHandLineString | FreeHandPolygon
    },
    symbol: {
      type: Object,
    },
    once: {
      type: Boolean,
      default: true
    },
    autoPanAtEdge: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      drawTool: null
    }
  },
  computed: {
    mergeOptions() {
      return mergeProps(this);
    }
  },
  mounted() {
    this.generateDrawTool();
  },
  destroyed() {
  },
  methods: {
    generateDrawTool() {
      this.drawTool = new maptalks.DrawTool(this.symbol ? this.mergeOptions : omit(this.mergeOptions, ['symbol']));
      bindEvent(this.drawTool, this, []);
      watchProps(this, this.drawTool, undefined, this.mergeOptions);
      this.enableChangeEvent();
      this.drawTool.addTo(this.map);
    },
    setEnable(val) {
      if (val) {
        this.enableDraw();
      } else {
        this.disableDraw();
      }
    },
    enableDraw() {
      if (!this.drawTool) return;
      this.drawTool.enable();
      this.$emit('update:enable', true);
    },
    disableDraw() {
      if (!this.drawTool) return;
      this.drawTool.disable();
      this.$emit('update:enable', false);
    },
    enableChangeEvent() {
      this.drawTool.on('enable', this.enableDraw);
      this.drawTool.on('disable', this.disableDraw);

      this.$once('hook:beforeDestroy', () => {
        this.drawTool.removeEventListener('enable', this.enableDraw);
        this.drawTool.removeEventListener('disable', this.disableDraw);
      });
    },
  }
};

/* script */
const __vue_script__$2 = script$2;

/* template */
var __vue_render__$2 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$2 = [];
__vue_render__$2._withStripped = true;

  /* style */
  const __vue_inject_styles__$2 = undefined;
  /* scoped */
  const __vue_scope_id__$2 = undefined;
  /* module identifier */
  const __vue_module_identifier__$2 = undefined;
  /* functional template */
  const __vue_is_functional_template__$2 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$2 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
    __vue_inject_styles__$2,
    __vue_script__$2,
    __vue_scope_id__$2,
    __vue_is_functional_template__$2,
    __vue_module_identifier__$2,
    false,
    undefined,
    undefined,
    undefined
  );

var tool = {
  props: {
    enable: {
      type: Boolean,
      default: true,
      custom: true
    }
  },
  data: function data() {
    return {
      tool: null
    };
  },
  computed: {
    mergeOptions: function mergeOptions() {
      return mergeProps(this);
    },
    toolSet: function toolSet() {
      return this.mapProvide && this.mapProvide.toolSet;
    }
  },
  methods: {
    setEnable: function setEnable(val) {
      var _this = this;

      if (!this.tool) return;
      this.disableAllTool();
      this.$nextTick(function () {
        if (val) {
          _this.tool.enable();
        } else {
          _this.tool.disable();
        }
      });
    },
    addToolToMap: function addToolToMap(tool) {
      if (this.toolSet) {
        this.toolSet.add(tool);
      }
    },
    bindEnableEvent: function bindEnableEvent() {
      this.tool.addEventListener('enable', this.enableEvent);
      this.tool.addEventListener('disable', this.disableEvent);
    },
    enableEvent: function enableEvent() {
      this.$emit('update:enable', true);
    },
    disableEvent: function disableEvent() {
      this.$emit('update:enable', false);
    },
    disableAllTool: function disableAllTool() {
      var _this2 = this;

      Array.from(this.toolSet).filter(function (tool) {
        return tool !== _this2.tool;
      }).forEach(function (tool) {
        return tool.disable();
      });
    }
  }
};

var measure = {
  props: {
    once: {
      type: Boolean,
      default: null
    },
    language: {
      type: String,
      default: 'zh-CN'
    },
    metric: {
      type: Boolean,
      default: true
    },
    imperial: {
      type: Boolean,
      default: false
    },
    symbol: {
      type: Object,
      default: function _default() {
        return {
          'lineColor': '#1bbc9b',
          'lineWidth': 2,
          'polygonFill': '#fff',
          'polygonOpacity': 0.3
        };
      }
    },
    vertexSymbol: {
      type: Object,
      default: function _default() {
        return {
          markerType: 'ellipse',
          markerFill: '#34495e',
          markerLineColor: '#1bbc9b',
          markerLineWidth: 3,
          markerWidth: 10,
          markerHeight: 10
        };
      }
    },
    labelOptions: {
      type: Object,
      default: function _default() {
        return {
          textSymbol: {
            textFaceName: 'monospace',
            textFill: '#fff',
            textLineSpacing: 1,
            textHorizontalAlignment: 'right',
            textDx: 15
          },
          boxStyle: {
            padding: [6, 2],
            symbol: {
              markerType: 'square',
              markerFill: '#000',
              markerFillOpacity: 0.9,
              markerLineColor: '#b4b3b3'
            }
          }
        };
      }
    }
  }
};

//

var script$1 = {
  name: 'MtDistanceTool',
  mixins: [map, options, tool, measure],
  mounted() {
    this.generateTools();
  },
  methods: {
    generateTools() {
      this.tool = new maptalks.DistanceTool(mergeProps(this));
      bindEvent(this.tool, this, []);
      watchProps(this, this.tool, [], this.mergeOptions);

      this.bindEnableEvent();

      this.addToolToMap(this.tool);
      this.tool.addTo(this.map);
      this.setEnable(this.enable);
    }
  }
};

/* script */
const __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__$1 = [];
__vue_render__$1._withStripped = true;

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = undefined;
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$1 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script = {
  name: 'MtAreaTool',
  mixins: [map, options, tool, measure],
  mounted() {
    this.generateTools();
  },
  methods: {
    generateTools() {
      this.tool = new maptalks.AreaTool(mergeProps(this));
      bindEvent(this.tool, this, []);
      watchProps(this, this.tool, [], this.mergeOptions);

      this.bindEnableEvent();

      this.addToolToMap(this.tool);
      this.tool.addTo(this.map);
      this.setEnable(this.enable);
    }
  }
};

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div")
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

var components = [__vue_component__$s, __vue_component__$r, __vue_component__$q, __vue_component__$p, __vue_component__$o, __vue_component__$n, __vue_component__$m, __vue_component__$l, __vue_component__$j, __vue_component__$k, __vue_component__$i, __vue_component__$h, __vue_component__$g, __vue_component__$f, __vue_component__$e, __vue_component__$d, __vue_component__$c, __vue_component__$b, __vue_component__$a, __vue_component__$9, __vue_component__$8, __vue_component__$7, __vue_component__$6, __vue_component__$5, __vue_component__$2, __vue_component__$1, __vue_component__, __vue_component__$4, __vue_component__$3];
var Vue2Maptalks = {};

Vue2Maptalks.install = function (Vue) {
  components.forEach(function (comp) {
    Vue.component(comp.name, comp);
  });
};

if (typeof window !== 'undefined' && window.Vue) {
  Vue2Maptalks.install(window.Vue);
}

exports.MtAreaTool = __vue_component__;
exports.MtAttribution = __vue_component__$b;
exports.MtCircle = __vue_component__$i;
exports.MtDistanceTool = __vue_component__$1;
exports.MtDrawTool = __vue_component__$2;
exports.MtEllipse = __vue_component__$h;
exports.MtImageLayer = __vue_component__$o;
exports.MtInfoWindow = __vue_component__$4;
exports.MtLabel = __vue_component__$l;
exports.MtLineString = __vue_component__$k;
exports.MtMap = __vue_component__$s;
exports.MtMarker = __vue_component__$m;
exports.MtMenu = __vue_component__$a;
exports.MtMultiLineString = __vue_component__$d;
exports.MtMultiPoint = __vue_component__$e;
exports.MtMultiPolygon = __vue_component__$c;
exports.MtOverview = __vue_component__$9;
exports.MtPanel = __vue_component__$8;
exports.MtParticleLayer = __vue_component__$n;
exports.MtPolygon = __vue_component__$j;
exports.MtRectangle = __vue_component__$g;
exports.MtScale = __vue_component__$7;
exports.MtSector = __vue_component__$f;
exports.MtTileLayer = __vue_component__$r;
exports.MtToolbar = __vue_component__$6;
exports.MtUMarker = __vue_component__$3;
exports.MtVectorLayer = __vue_component__$q;
exports.MtWmsLayer = __vue_component__$p;
exports.MtZoom = __vue_component__$5;
exports.Vue2Maptalks = Vue2Maptalks;
